package com.indicee.customtabledemo.server;

import java.util.List;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import com.indicee.api.connector.IndiceeAPIConnector;
import com.indicee.api.objects.ViewWindow;
import com.indicee.api.objects.report.Report;
import com.indicee.api.objects.report.view.filter.Filter;
import com.indicee.api.services.ReportService;
import com.indicee.api.services.impl.ReportServiceImpl;
import com.indicee.customtabledemo.client.IndiceeDataService;

/**
 * The server side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class IndiceeDataServiceImpl extends RemoteServiceServlet implements IndiceeDataService {

    private static IndiceeAPIConnector connector = new IndiceeAPIConnector("https://test.indicee.com",
            "67523805-e3fc-4620-a4bc-b62ae4bc2b1a", "787c3c200403e2592b5d931fb3cc3e94",
            "XXXXX", "XXXXX");
    private static ReportService reportService = new ReportServiceImpl(connector);

    @Override
    public Report getReport(int id) throws Exception {
        return getReport(id, new ViewWindow(0, 1000000));
    }

    @Override
    public Report getReport(int id, ViewWindow viewWindow) throws Exception {
        Report report = reportService.getReport(id, viewWindow);
        return report;
    }

    @Override
    public Report getReport(int id, List<Filter> fieldFilters) throws Exception {
        return getReport(id, fieldFilters, new ViewWindow(0, 1000000));
    }

    @Override
    public Report getReport(int id, List<Filter> fieldFilters, ViewWindow viewWindow) throws Exception {
        Report report = reportService.getReport(id, fieldFilters, viewWindow);
        return report;
    }
}
