package com.indicee.api.connector.exception;

import java.io.Serializable;

import com.indicee.api.connector.IndiceeAPIConnector;

/**
 * This exception is thrown by the {@link IndiceeAPIConnector}. It gets thrown
 * when there is some sort of connection issue with the Indicee server, or the
 * server returns an error.
 * 
 * @author victork
 * 
 */
public class IndiceeAPIConnectorException extends Exception implements Serializable {

    private static final long serialVersionUID = -1569772755250358646L;
    private String path;

    public IndiceeAPIConnectorException(String message) {
        super(message);
    }

    public IndiceeAPIConnectorException(String message, Throwable t) {
        super(message, t);
    }

    public IndiceeAPIConnectorException(String message, String path, Throwable t) {
        super(message + "\nError occured connecting to: " + path, t);
        this.path = path;
    }

    public String getPath() {
        return path;
    }
}
