package com.indicee.api.connector.util;

import java.io.InputStream;

public class InputStreamWrapper {

    public enum MimeType {
        CSV("text/csv"), EXCEL("application/vnd.ms-excel"), TSV("text/tsv");
        private final String contentType;

        private MimeType(String contentType) {
            this.contentType = contentType;
        }

        public String getContentType() {
            return contentType;
        }
    }

    public InputStream getInputSteam() {
        return inputSteam;
    }

    public String getFileName() {
        return fileName;
    }

    private final InputStream inputSteam;
    private final String fileName;
    private final MimeType mimeType;

    public InputStreamWrapper(InputStream inputSteam, MimeType mimeType, String fileName) {
        this.inputSteam = inputSteam;
        this.mimeType = mimeType;
        this.fileName = fileName;
    }

    public MimeType getMimeType() {
        return mimeType;
    }
}
