package com.indicee.api.objects.model;

import java.io.Serializable;

public class Attribute implements Serializable {

    public enum Type {
        String("String");
        private String value;

        private Type(String value) {
            this.value = value;
        }

        public static Type get(String name) {
            for (Type type : Type.values()) {
                if (type.value.equals(name)) {
                    return type;
                }
            }
            return null;
        }
    }

    private static final long serialVersionUID = -3985911853731623913L;
    private String value;
    private Type type;
    private String name;

    public Attribute() {

    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public void setType(Type type) {
        this.type = type;
    }

    public Type getType() {
        return type;
    }

}
