package com.indicee.api.objects.model;

import java.io.Serializable;
import java.util.List;

public class Field implements Serializable {

    private static final long serialVersionUID = 4726890561018893502L;

    public enum AggregateType {
        Latest("Latest"), Sum("Sum");
        private String value;

        private AggregateType(String value) {
            this.value = value;
        }

        public static AggregateType get(String name) {
            for (AggregateType aggregateType : AggregateType.values()) {
                if (aggregateType.value.equals(name)) {
                    return aggregateType;
                }
            }
            return null;
        }
    }

    public enum DataType {
        String("STRING"), Number("NUMBER"), Date("DATE");
        private String value;

        private DataType(String value) {
            this.value = value;
        }

        public static DataType get(String name) {
            for (DataType dataType : DataType.values()) {
                if (dataType.value.equals(name)) {
                    return dataType;
                }
            }
            return null;
        }
    }

    public enum TrackingType {
        Type1("Type1");
        private String value;

        private TrackingType(String value) {
            this.value = value;
        }

        public static TrackingType get(String name) {
            for (TrackingType trackingType : TrackingType.values()) {
                if (trackingType.value.equals(name)) {
                    return trackingType;
                }
            }
            return null;
        }
    }

    private String uuid;
    private String name;
    private String qname;
    private List<Attribute> attributes;
    private TrackingType trackingType;
    private DataType dataType;
    private AggregateType aggregateType;
    private String formula;

    public Field() {
    }

    public AggregateType getAggregateType() {
        return aggregateType;
    }

    public List<Attribute> getAttributes() {
        return attributes;
    }

    public DataType getDataType() {
        return dataType;
    }

    public String getName() {
        return name;
    }

    public String getQname() {
        return qname;
    }

    public TrackingType getTrackingType() {
        return trackingType;
    }

    public String getUuid() {
        return uuid;
    }

    public void setAggregateType(AggregateType aggregateType) {
        this.aggregateType = aggregateType;
    }

    public void setAttributes(List<Attribute> attributes) {
        this.attributes = attributes;
    }

    public void setDataType(DataType dataType) {
        this.dataType = dataType;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setQname(String qname) {
        this.qname = qname;
    }

    public void setTrackingType(TrackingType trackingType) {
        this.trackingType = trackingType;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }

    public void setFormula(String formula) {
        this.formula = formula;
    }

    public String getFormula() {
        return formula;
    }
}
