package com.indicee.api.objects.report;

import java.io.Serializable;

public class Metadata implements Serializable {

    private static final long serialVersionUID = 280237584535232464L;

    private String key;
    private String value;

    public Metadata() {
    }

    public Metadata(String key, String value) {
        this.key = key;
        this.value = value;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getKey() {
        return key;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj != null && obj instanceof Metadata) {
            Metadata other = (Metadata) obj;
            if (key == null ? other.key == null : other.key.equals(key) && value == null ? other.value == null
                    : other.value.equals(value)) {
                return true;
            }
        }
        return false;
    }

    @Override
    public String toString() {
        return "<entry key=\"" + key + "\" value=\"" + value + "\" />";
    }
}
