package com.indicee.api.objects.report.data;

import java.io.Serializable;
import java.util.List;

public class Data implements Serializable {

    private static final long serialVersionUID = -7943656981512035657L;
    private int totalColumns;
    private int totalRows;
    private List<DataRow> reportDataRows;

    public void setTotalColumns(int totalColumns) {
        this.totalColumns = totalColumns;
    }

    public int getTotalColumns() {
        return totalColumns;
    }

    public void setTotalRows(int totalRows) {
        this.totalRows = totalRows;
    }

    public int getTotalRows() {
        return totalRows;
    }

    public void setReportDataRows(List<DataRow> reportDataRows) {
        this.reportDataRows = reportDataRows;
    }

    public List<DataRow> getReportDataRows() {
        return reportDataRows;
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

    public String toFormatedString() {
        return toString("\n", "\t", "");
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<data>").append(newLine);
        for (DataRow row : reportDataRows) {
            sb.append(row.toString(newLine, tab, indent + tab)).append(newLine);
        }
        sb.append(indent).append("</data>");
        return sb.toString();
    }
}
