package com.indicee.api.objects.report.view.axes;

import java.io.Serializable;
import java.util.List;

import com.indicee.api.objects.report.IndiceeObject;

public class Axis extends IndiceeObject implements Serializable {

    private static final long serialVersionUID = -1136348447395899713L;

    private String name;
    private List<Layer> layers;
    private List<AxisSort> axisSortings;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Layer> getLayers() {
        return layers;
    }

    public void setLayers(List<Layer> layers) {
        this.layers = layers;
    }

    @Override
    public String toString() {
        return toString("", "", "");
    }

    public String toFormatedString() {
        return toString("\n", "\t", "");
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<axis name=\"" + name + "\">").append(newLine);
        sb.append(indent + tab).append("<layers>").append(newLine);
        for (Layer layer : layers) {
            sb.append(layer.toString(newLine, tab, indent + tab + tab)).append(newLine);
        }
        sb.append(indent + tab).append("</layers>").append(newLine);
        if (axisSortings != null && !axisSortings.isEmpty()) {
            sb.append(indent + tab).append("<axissorting>").append(newLine);
            for (AxisSort axisSort : axisSortings) {
                sb.append(axisSort.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
            sb.append(indent + tab).append("</axissorting>").append(newLine);
        }
        sb.append(indent).append("</axis>");
        return sb.toString();
    }

    public void setAxisSortings(List<AxisSort> axisSortings) {
        this.axisSortings = axisSortings;
    }

    public List<AxisSort> getAxisSortings() {
        return axisSortings;
    }
}
