package com.indicee.api.objects.report.view.axes;

import java.io.Serializable;
import java.util.List;

import com.indicee.api.objects.report.IndiceeObject;
import com.indicee.api.objects.report.view.attributes.AttributesOrigin;

public class AxisSort extends IndiceeObject implements Serializable {

    private static final long serialVersionUID = -82301717445356292L;

    private boolean ascending;
    private boolean breakHierarchies;
    private QueryValue queryValue;
    private List<AttributesOrigin> attributes;

    public void setAscending(boolean ascending) {
        this.ascending = ascending;
    }

    public boolean isAscending() {
        return ascending;
    }

    public void setBreakHierarchies(boolean breakHierarchies) {
        this.breakHierarchies = breakHierarchies;
    }

    public boolean isBreakHierarchies() {
        return breakHierarchies;
    }

    public void setQueryValue(QueryValue queryValue) {
        this.queryValue = queryValue;
    }

    public QueryValue getQueryValue() {
        return queryValue;
    }

    public void setAttributes(List<AttributesOrigin> attributes) {
        this.attributes = attributes;
    }

    public List<AttributesOrigin> getAttributes() {
        return attributes;
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append(
                "<axissort ascending=\"" + ascending + "\" breakhierarchies=\"" + breakHierarchies + "\">").append(
                newLine);
        sb.append(queryValue.toString(newLine, tab, indent + tab)).append(newLine);
        sb.append(indent + tab).append("<attributes>").append(newLine);
        for (AttributesOrigin attribute : attributes) {
            sb.append(attribute.toString(newLine, tab, indent + tab + tab)).append(newLine);
        }
        sb.append(indent + tab).append("</attributes>").append(newLine);
        sb.append(indent).append("</axissort>");
        return sb.toString();
    }
}
