package com.indicee.api.objects.report.view.axes;

import java.io.Serializable;
import java.util.List;

public class GroupingAxisLayer extends Layer implements Serializable {

    private static final long serialVersionUID = 6303669075793800208L;
    private boolean leadingTotals;
    private boolean trailingTotals;
    private String hierarchy;
    private String hierarchyDisplay;
    private boolean drillable;
    private LayerQueryGrouping queryGrouping;
    private LayerGroupSorting groupSorting;
    private List<GroupFilter> groupFilters;

    public boolean isLeadingTotals() {
        return leadingTotals;
    }

    public void setLeadingTotals(boolean leadingTotals) {
        this.leadingTotals = leadingTotals;
    }

    public boolean isTrailingTotals() {
        return trailingTotals;
    }

    public void setTrailingTotals(boolean trailingTotals) {
        this.trailingTotals = trailingTotals;
    }

    public String getHierarchy() {
        return hierarchy;
    }

    public void setHierarchy(String hierarchy) {
        this.hierarchy = hierarchy;
    }

    public String getHierarchyDisplay() {
        return hierarchyDisplay;
    }

    public void setHierarchyDisplay(String hierarchyDisplay) {
        this.hierarchyDisplay = hierarchyDisplay;
    }

    public boolean isDrillable() {
        return drillable;
    }

    public void setDrillable(boolean drillable) {
        this.drillable = drillable;
    }

    public LayerQueryGrouping getQueryGrouping() {
        return queryGrouping;
    }

    public void setQueryGrouping(LayerQueryGrouping queryGrouping) {
        this.queryGrouping = queryGrouping;
    }

    public LayerGroupSorting getGroupSorting() {
        return groupSorting;
    }

    public void setGroupSorting(LayerGroupSorting groupSorting) {
        this.groupSorting = groupSorting;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append(
                "<groupingaxislayer leadingtotals=\"" + leadingTotals + "\" trailingtotals=\"" + trailingTotals
                        + "\" hierarchy=\"" + hierarchy + "\" hierarchydisplay=\"" + hierarchyDisplay
                        + "\" drillable=\"" + drillable + "\">").append(newLine);
        sb.append(queryGrouping.toString(newLine, tab, indent + tab)).append(newLine);
        sb.append(groupSorting.toString(newLine, tab, indent + tab)).append(newLine);
        if (groupFilters != null && !groupFilters.isEmpty()) {
            sb.append(indent + tab).append("<groupfilters>").append(newLine);
            for (GroupFilter groupFilter : groupFilters) {
                sb.append(groupFilter.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
            sb.append(indent + tab).append("</groupfilters>").append(newLine);
        }
        sb.append(indent).append("</groupingaxislayer>");
        return sb.toString();
    }

    public void setGroupFilters(List<GroupFilter> groupFilters) {
        this.groupFilters = groupFilters;
    }

    public List<GroupFilter> getGroupFilters() {
        return groupFilters;
    }
}
