package com.indicee.api.objects.report.view.axes;

import java.io.Serializable;
import java.util.List;

import com.indicee.api.objects.report.view.attributes.AttributesOrigin;

public class QueryValue implements Serializable {

    private static final long serialVersionUID = -8423097208076103369L;
    private String field;
    private String entity;
    private String aggregator;

    private List<AttributesOrigin> attributes;

    public String getField() {
        return field;
    }

    public void setField(String field) {
        this.field = field;
    }

    public String getEntity() {
        return entity;
    }

    public void setEntity(String entity) {
        this.entity = entity;
    }

    public String getAggregator() {
        return aggregator;
    }

    public void setAggregator(String aggregator) {
        this.aggregator = aggregator;
    }

    public List<AttributesOrigin> getAttributes() {
        return attributes;
    }

    public void setAttributes(List<AttributesOrigin> attributes) {
        this.attributes = attributes;
    }

    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        sb.append(indent).append("<queryvalue ");
        if (field != null) {
            sb.append("field=\"" + field + "\" ");
        }
        sb.append("entity=\"" + entity + "\" aggregator=\"" + aggregator + "\">").append(newLine);
        sb.append(indent + tab).append("<attributes>").append(newLine);
        for (AttributesOrigin originAttribute : attributes) {
            sb.append(originAttribute.toString(newLine, tab, indent + tab + tab)).append(newLine);
        }
        sb.append(indent + tab).append("</attributes>").append(newLine);
        sb.append(indent).append("</queryvalue>");
        return sb.toString();
    }
}
