package com.indicee.api.objects.report.view.filter;

import java.io.Serializable;
import java.util.List;

public class FieldFilter extends Filter implements Serializable {

    private static final long serialVersionUID = 2527038416303587156L;
    private List<FieldFilterValue> values;
    private String entity;

    public String getEntity() {
        return entity;
    }

    public List<FieldFilterValue> getValues() {
        return values;
    }

    public void setEntity(String entity) {
        this.entity = entity;
    }

    public void setValues(List<FieldFilterValue> values) {
        this.values = values;
    }

    @Override
    public String toString(String newLine, String tab, String indent) {
        StringBuilder sb = new StringBuilder();
        if (values.size() == 1) {
            sb.append(indent).append(
                    "<fieldfilter field=\"" + getField() + "\" inclusive=\"" + isInclusive() + "\" value=\""
                            + htmlEncode(values.get(0).getValue()) + "\"");
            if (entity != null && !entity.isEmpty()) {
                sb.append(" entity=\"" + entity + "\"");
            }
            sb.append("/>");
        } else {
            sb.append(indent).append("<fieldfilter field=\"" + getField() + "\" inclusive=\"" + isInclusive() + "\"")
                    .append(newLine);
            if (entity != null && !entity.isEmpty()) {
                sb.append(" entity=\"" + entity + "\"");
            }
            sb.append(">");
            sb.append(indent + tab).append("<values>").append(newLine);
            for (FieldFilterValue value : values) {
                sb.append(value.toString(newLine, tab, indent + tab + tab)).append(newLine);
            }
            sb.append(indent + tab).append("</values>").append(newLine);
            sb.append(indent).append("</fieldfilter>");
        }
        return sb.toString();
    }
}
