package com.indicee.api.parser;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;

import com.sun.org.apache.xerces.internal.parsers.DOMParser;

public abstract class IndiceeParser {

    protected static boolean getBoolean(Node child) {
        return Boolean.parseBoolean(child.getFirstChild().getNodeValue());
    }

    protected static Document getDocumentFromString(String xmlDocument) {
        InputStream body = new ByteArrayInputStream(xmlDocument.getBytes());
        DOMParser parser = new DOMParser();
        try {
            parser.parse(new InputSource(body));
        } catch (Exception e) {
            throw new RuntimeException("Exception parsing xml string.", e);
        }
        return parser.getDocument();
    }

    protected static double getDouble(Node child) {
        return Double.parseDouble(child.getFirstChild().getNodeValue());
    }

    protected static int getInteger(Node child) {
        return Integer.parseInt(child.getFirstChild().getNodeValue());
    }

    protected static String getString(Node child) {
        return child.getFirstChild() != null ? child.getFirstChild().getNodeValue() : "";
    }
}
